<%-- $Id:manual_scan.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	ExtensionsControl ec = ExtensionsControl.get(dc);
	ec.checkPermission(Permission.WRITE);
	%>
	<base:page type="popup" title="Start manual scan">
	<base:head>
		<script language="JavaScript">
		
		// Submit the form
		function startManualScan()
		{
			var frm = document.forms['scan'];
			frm.submit();
		}
		</script>
	</base:head>
	<base:body>
	<p>

	<form action="index.jsp?ID=<%=ID%>" method="post" name="scan" onsubmit="return false;">
	<input type=hidden name="cmd" value="DoManualScan">
	
	<h3 class="docked">Perform manual scan <base:help helpid="extensions.manualscan" /></h3>
	<div class="boxedbottom">

		<div class="helpmessage">
		A manual scan will check the extensions directory for new, updated
		or deleted extensions. If <b>Force update</b> is selected, extensions
		that are unchanged will also be updated.
		</div>

		<table class="form" cellspacing=0>
		<tr>
			<td class="prompt">Force update</td>
			<td>
				<input type="checkbox" class="text" name="forceUpdate" value="1"> 
			</td>
		</tr>
		</table>
	
	</div>
	
	<p>
	<div align=center>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="startManualScan();" title="Start" image="gonext.gif" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>

	</div>
	</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
