<%-- $Id: edit_mapping.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATEMAPPING;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PlateMapping mapping = null;
	ItemResultList<PlateGeometry> plateGeometries = null;
	
	boolean readCurrentSourceGeometry = true;
	PlateGeometry currentSourceGeometry = null;
	int currentSourceGeometryId = 0;
	
	boolean readCurrentDestinationGeometry = true;
	PlateGeometry currentDestinationGeometry = null;
	int currentDestinationGeometryId = 0;
	
	if (itemId == 0)
	{
		title = "Create plate mapping";
		cc.removeObject("item");
		
		ItemQuery<PlateGeometry> geometryQuery = PlateGeometry.getQuery();
		geometryQuery.order(Orders.asc(Hql.property("name")));
		geometryQuery.setCacheResult(true);

		plateGeometries = geometryQuery.list(dc);
		currentSourceGeometryId = Values.getInt(cc.getPropertyValue("sourceGeometry"), 0);
		currentDestinationGeometryId = Values.getInt(cc.getPropertyValue("destinationGeometry"), 0);
	}
	else
	{
		mapping = PlateMapping.getById(dc, itemId);
		cc.setObject("item", mapping);
		title = "Edit plate mapping -- " + HTML.encodeTags(mapping.getName());
		
		try
		{
			currentSourceGeometry = mapping.getSourceGeometry();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSourceGeometry = false;
		}
		try
		{
			currentDestinationGeometry = mapping.getDestinationGeometry();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentDestinationGeometry = false;
		}
	}
	if (mapping != null && !mapping.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "PlateMapping" tab
		function validatePlateMapping()
		{
			var frm = document.forms['mapping'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['mapping'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}

		function updateImage()
		{
			var frm = document.forms['mapping'];
			var newSrc = frm.image.value;
			var imageSrc = '../../images/platemappings/'+newSrc;
			var image = document.getElementById('mappingImage');
			if (image && newSrc && imageSrc != image.src)
			{
				image.src = imageSrc;
			}
		}

		function init()
		{
			var frm = document.forms['mapping'];
			<%
			if (mapping == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="mapping" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" 
			position="bottom" remember="<%=mapping != null%>">
		<t:tab id="info" title="Plate mapping" validate="validatePlateMapping()" helpid="platemapping.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(mapping == null ? Values.getString(cc.getPropertyValue("name"), "New plate mapping") : mapping.getName())%>" 
					size="40" maxlength="<%=PlateMapping.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Source plates</td>
				<td>
					<%
					if (mapping == null)
					{
						%>
						<input <%=requiredClazz%> type="text" name="source_count" 
							value="<%=Values.getInt(cc.getPropertyValue("sourceCount"), 1)%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
						plate(s) of
						<select name="sourcegeometry_id" class="required">
						<%
						for (PlateGeometry pg : plateGeometries)
						{
							%>
							<option value="<%=pg.getId()%>" <%=pg.getId() == currentSourceGeometryId ? "selected" : ""%>><%=HTML.encodeTags(pg.getName())%>
							<%
						}
						%>
						</select><br>
						can't be changed later
						<%
					}
					else
					{
						%>
						<%=mapping.getSourceCount()%> plate(s) of 
						<%=Base.getEncodedName(currentSourceGeometry, !readCurrentSourceGeometry)%>
						<%
					}
					%>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Destination plates</td>
				<td>
					<%
					if (mapping == null)
					{
						%>
						<input <%=requiredClazz%> type="text" name="destination_count" 
							value="<%=Values.getInt(cc.getPropertyValue("destinationCount"), 1)%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
						plate(s) of
						<select name="destinationgeometry_id" class="required">
						<%
						for (PlateGeometry pg : plateGeometries)
						{
							%>
							<option value="<%=pg.getId()%>" <%=pg.getId() == currentDestinationGeometryId ? "selected" : ""%>><%=HTML.encodeTags(pg.getName())%>
							<%
						}
						%>
						</select><br>
						can't be changed later
						<%
					}
					else
					{
						%>
						<%=mapping.getDestinationCount()%> plate(s) of 
						<%=Base.getEncodedName(currentDestinationGeometry, !readCurrentDestinationGeometry)%>
						<%
					}
					%>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Image</td>
				<td>
					<input <%=clazz%> type="text" name="image" 
						value="<%=HTML.encodeTags(mapping == null ? "" : mapping.getImage())%>" 
						size="40" maxlength="<%=PlateMapping.MAX_IMAGE_LENGTH%>" 
						onBlur="updateImage()">
						<br><br>
						<%
						String src = "noimage.gif";
						if (mapping != null && mapping.getImage() != null)
						{
							src = mapping.getImage();
						}
						%>
						<img id="mappingImage" src="../../images/platemappings/<%=src%>">
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(mapping == null ? cc.getPropertyValue("description") : mapping.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'mapping', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
