<%-- $Id: jep_intensity_transformer.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = sc.getCurrentContext(Item.BIOASSAYSET);
DbControl dc = null;
try
{
	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	RequestInformation info = pcRequest.getRequestInformation();
	
	dc = sc.newDbControl();
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(job, false);
	BioAssaySet source = null;
	source = (BioAssaySet)job.getParameterValue("source");
	if (source == null && cc.getId() != 0) source = BioAssaySet.getById(dc, cc.getId());
	if (source == null) throw new WebException("popup", "No current bioassay set", 
		"Could not find any current bioassay set. Please select a bioassay set before trying again");
	source = BioAssaySet.getById(dc, source.getId());
	int maxRawMappings = source.getMaxRawMappingsForSpot();

	RawDataType rdt = source.getRawDataType();
	
	// Current parameter values
	String childName = Values.getString((String)job.getParameterValue("childName"), source.getName());
	String childDescription = (String)job.getParameterValue("childDescription");
	String transformationName = (String)job.getParameterValue("transformationName");
	
	// Predefined formulas
	ItemQuery<Formula> formulaQuery = Formula.getQuery(Formula.Type.INTENSITY_TRANSFORMATION, rdt,
			source.getIntensityTransform());
	formulaQuery.order(Orders.asc(Hql.property("name")));
	formulaQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	ItemResultList<Formula> formulas = formulaQuery.list(dc);
	%>
	<base:page type="popup" title="Transform intensities">
	<base:head styles="parameters.css">
		<script language="JavaScript">
		function hideErrorList()
		{
			Main.hide('errorlist');
			Main.show('showerrorlist');
		}
		function showErrorList()
		{
			Main.show('errorlist');
			Main.hide('showerrorlist');
		}
		function presetOnChange()
		{
			var frm = document.forms['transformation'];
			var formulaId = frm.presets[frm.presets.selectedIndex].value;
			frm['parameter:transformationName'].value = frm.presets[frm.presets.selectedIndex].text;
			for (var ch = 1; ch <= <%=rdt.getChannels()%>; ch++)
			{
				frm['parameter:ch'+ch+'.expression'].value = formulas[formulaId+'.'+ch];
			}
			Forms.selectListOption(frm['parameter:resultTransform'], formulas[formulaId+'.resultTransform']);
			frm.presets.selectedIndex = 0;
		}
		function openExpressionBuilder(title, inputName)
		{
			Main.expressionBuilder('<%=ID%>', title, 'transformation', inputName, 'INTENSITY_TRANSFORMATION', '<%=rdt.getId()%>', <%=rdt.getChannels()%>, false, '<%=source.getId()%>');
		}
		function validate()
		{
			var frm = document.forms['transformation'];
			for (var ch = 1; ch <= <%=rdt.getChannels()%>; ch++)
			{
				var inputName = 'parameter:ch'+ch+'.expression';
				if (Main.trimString(frm[inputName].value) == '')
				{
					alert('You must enter an expression for channel ' + ch);
					frm[inputName].focus();
					return false;
				}
				else if (<%=maxRawMappings != 1 ? "true" : "false"%> && frm[inputName].value.search(/raw\(/) != -1)
				{
					alert('Can\'t use function raw() for bioassaysets with multiple mappings to raw data');
					frm[inputName].focus();
					return false;
				}
			}
			return true;
		}
		function doNext()
		{
			if (validate())
			{
				var frm = document.forms['transformation'];
				frm.submit();
			}
		}
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}
		
		var formulas = new Array();
		function init()
		{
			<%
			for (Formula f : formulas)
			{
				IntensityTransform result = f.getResultIntensityTransform();
				%>
				formulas['<%=f.getId()%>.resultTransform'] = '<%=result == null ? "" : result.name()%>';
				<%
				for (int ch = 1; ch <= rdt.getChannels(); ++ch)
				{
					String formula = f.getFormula(ch-1);
					%>
					formulas['<%=f.getId()%>.<%=ch%>'] = '<%=HTML.javaScriptEncode(formula)%>';
					<%
				}
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<form name="transformation" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="parameter:source" value="<%=source.getId()%>">
		
		<h3 class="docked">Transform intensities <base:help helpid="jepintensitytransformer.options"/></h3>
		<div class="boxed">
		<%
		if (errorMessage != null || (errors != null && errors.size() > 0))
		{
			%>
			<div id="errors" style="margin-bottom: 12px;" class="parameterhelp">
				<div class="error" style="margin: 0px;">
				<%=errorMessage %>
				</div>
				<%
				if (errors != null && errors.size() > 0)
				{
					%>
					<div id="showerrorlist" style="display: none;">
						<base:icon image="bullet.gif" /><a href="javascript:showErrorList()">Show details</a>
					</div>
					<div id="errorlist">
					<ol>
					<%
					for (Throwable t : errors)
					{
						%>
						<li><%=t.getMessage()%><br>
						<%
					}
					%>
					</ol>
					<base:icon image="bullet.gif" /><a href="javascript:hideErrorList()">Hide details</a>
					</div>
					<%
				}
				%>
			</div>
			<%
		}
		%>

			<table class="form" width="100%">
			<tr valign="top">
				<td class="prompt">Source bioassay set</td>
				<td><%=HTML.encodeTags(source.getName())%></td>
			</tr>			
			<tr>
				<td class="prompt" colspan="2">Child bioassay set</td>
			</tr>
			<tr>
				<td style="text-align: right">Name</td>
				<td>
					<input type="text" class="text required" size="50" maxlength="255" name="parameter:childName" 
						value="<%=HTML.encodeTags(childName)%>"></td>
			</tr>
			<tr valign="top">
				<td style="text-align: right">Description</td>
				<td nowrap>
					<textarea class="text" rows="4" cols="50" name="parameter:childDescription" wrap="virtual"
						><%=HTML.encodeTags(childDescription)%></textarea>
					<a href="javascript:Main.zoom('Description', 'transformation', 'parameter:childDescription')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr>
				<td class="prompt">Transformation</td>
				<td>
				<%
				if (formulas.size() > 0)
				{
					%>
					<select name="presets" style="width: 32em;"
						onchange="presetOnChange()" 
						>
						<option value="">- select from list or enter formula below -
						<%
						for (Formula f : formulas)
						{
							boolean ok = true;
							if (maxRawMappings != 1)
							{
								for (String formula : f.getFormulas())
								{
									ok &= !formula.contains("raw(");
								}
							}
							if (ok)
							{
								%>
								<option value="<%=f.getId()%>" title="<%=HTML.encodeTags(f.getDescription())%>"
									><%=HTML.encodeTags(f.getName())%>
								<%
							}
						}
						%>
					</select>
					<%
				}
				%>
				</td>
			</tr>
			<tr>
				<td style="text-align: right">Name</td>
				<td>
					<input type="text" class="text" size="50" maxlength="255" name="parameter:transformationName" 
						value="<%=HTML.encodeTags(transformationName)%>"></td>
			</tr>
			
			<%
			for (int ch = 1; ch <= rdt.getChannels(); ++ch)
			{
				String inputName = "parameter:ch" + ch + ".expression";
				String value = (String)job.getParameterValue("ch"+ch+".expression");
				if (value == null) value = (String)info.getParameter("ch"+ch+".expression").getParameterType().getDefaultValue();
				%>
				<tr valign="top">
					<td style="text-align: right">Ch <%=ch%></td>
					<td>
						<table border="0" cellspacing="0" cellpadding="0">
						<tr valign="top">
						<td>
							<input type="text" class="text required" name="<%=inputName%>"
								size="50" 
								value="<%=HTML.encodeTags(value)%>">&nbsp;
						</td>
						<td><base:button onclick="<%="openExpressionBuilder('Ch "+ch+" expression', '"+inputName+"')"%>" 
							title=""
							image="expression_builder.gif"
							tooltip="A simple utility for building expressions" />
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td style="text-align: right">Resulting transform</td>
				<td>
					<input type="hidden" name="parameter:resultTransform:emptyIsNull" value="1" />
					<select name="parameter:resultTransform">
					<option value="">- same as source data -
					<%
					for (IntensityTransform t : IntensityTransform.values())
					{
						%>
						<option value="<%=t.name()%>"><%=t.toString()%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			</table>
		</div>
		</form>
	
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="doNext();" title="Next" /></td>
			<td width="50%"><base:button onclick="doCancel();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}%>
