<%-- $Id: ajax.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.util.AjaxWriter"
	import="java.util.Date"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
out.clear();
AjaxWriter aw = new AjaxWriter(out);
DbControl dc = null;
try
{
	if ("GetProgress".equals(cmd))
	{
		dc = sc.newDbControl();
		Job job = Job.getById(dc, itemId);
		aw.ajaxPrintEntry("job.id", job.getId());
		aw.ajaxPrintEntry("job.status", job.getStatus().name());
		aw.ajaxPrintEntry("job.message", HTML.niceFormat(job.getStatusMessage()));
		aw.ajaxPrintEntry("job.percent-complete", job.getPercentComplete());
		Date started = job.getStarted();
		if (started != null)
		{
			Date ended = job.getEnded();
			if (ended == null) ended = new Date();
			long runningTime = ended.getTime() - started.getTime();
			aw.ajaxPrintEntry("job.running-time", Values.formatTime(runningTime / 1000));
		}
		aw.ajaxEndRecord();
		dc.commit();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	aw.flush();
	if (dc != null) dc.close();
}
%>